unit ESC2021_1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, Grids, StdCtrls,
   LazUTF8, math;



type

   TSortType = (SortInt,SortUint, SortFloat,SortString);

	 { TForm1 }

   TForm1 = class(TForm)
			Button2: TButton;
			Label1: TLabel;
			StringGrid1: TStringGrid;
			procedure Button2Click(Sender: TObject);
			procedure FormCreate(Sender: TObject);
			procedure StringGrid1CompareCells(Sender: TObject; ACol, ARow, BCol,
				 BRow: Integer; var Result: integer);
			procedure StringGrid1HeaderClick(Sender: TObject; IsColumn: Boolean;
				 Index: Integer);
      Procedure LoadGrid;
   private
     SortArray: array of TSortType;
     Procedure initSortArray (ar: array Of TSortType);
   public

   end;






var
   Form1: TForm1;

implementation

{$R *.lfm}
const ESCdat =   './ESCsort.dat';

{ TForm1 }


Procedure TForm1.LoadGrid;
var x,y, jury, people,i : Integer;
	  err : single;
    s: string;
begin

   StringGrid1.LoadFromCSVFile(ESCdat,'/',true,0,false);
   with StringGrid1 do
      begin
       for y := 0 to RowCount-1 do
          begin
          for x := 0 To colcount -1 do
            begin
             cells[x,y] := Trim(cells[x,y]);
						end;
					end;

			end; // with
	 StringGrid1.MoveColRow(true,1,4);
   //StringGrid1.FixedRows:= 1;


   for y := 1 to StringGrid1.RowCount-1 do
      begin
      Jury := StrToInt(StringGrid1.cells[5,y]);
      people := StrToInt(StringGrid1.cells[6,y]);
      s := IntToStr(Jury-people);
      StringGrid1.cells[7,y]:= s;
      StringGrid1.Cells[8,y] := IntToStr(y);
			end;
end;




procedure TForm1.Button2Click(Sender: TObject);
begin
   Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   initSortArray ([SortInt,SortString,SortString,SortString,
                  SortInt,SortInt,SortInt,SortInt]);
   LoadGrid;
end;

procedure TForm1.StringGrid1CompareCells(Sender: TObject; ACol, ARow, BCol,
	 BRow: Integer; var Result: integer);
var  SortTag: TSortType;

begin
result := 0;
SortTag := SortArray[ACol];
with StringGrid1 do
   begin
     case SortTag of
       SortInt :result := StrToInt64Def(Cells[ACol,ARow],0)-StrToInt64Def(Cells[BCol,BRow],0);
       SortUint :result := StrToQWordDef(Cells[ACol,ARow],0)-StrToQwordDef(Cells[BCol,BRow],0);
       SortFloat :result := round(StrToFloatDef(Cells[ACol,ARow],0)-StrToFloatDef(Cells[BCol,BRow],0));
       SortString:result := UTF8CompareStr(Cells[ACol,ARow], Cells[BCol,BRow]);
     end; // case
  if SortOrder = soDescending then result := -result;
end;// with
end;

procedure TForm1.StringGrid1HeaderClick(Sender: TObject; IsColumn: Boolean;
	 Index: Integer);
var y : integer;
begin
   For y := 1 to StringGrid1.RowCount - 1 do
           StringGrid1.cells[8,y] := IntToStr(y);
end;

Procedure TForm1.initSortArray (ar: array Of TSortType);
var i : integer;
begin
setLength(SortArray,length(ar));
for i := 0 to high (ar) do SortArray[i] := ar[i];
end;



end.

